diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-utils.cc ns-3.31/src/wifi/model/wifi-utils.cc
--- ns-3.30.1/src/wifi/model/wifi-utils.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-utils.cc	2020-06-27 17:38:30.000000000 -0700
@@ -137,7 +137,7 @@
     }
   else if (modulation == WIFI_MOD_CLASS_HT && useGreenfield)
     {
-      //If protection for greenfield is used we go for HT_MF preamble which is the default protection for GF format defined in the standard.
+      //If protection for Greenfield is used we go for HT_MF preamble which is the default protection for GF format defined in the standard.
       return WIFI_PREAMBLE_HT_GF;
     }
   else if (modulation == WIFI_MOD_CLASS_HT)
@@ -196,6 +196,16 @@
 }
 
 uint32_t
+GetBlockAckRequestSize (BlockAckType type)
+{
+  WifiMacHeader hdr;
+  hdr.SetType (WIFI_MAC_CTL_BACKREQ);
+  CtrlBAckRequestHeader bar;
+  bar.SetType (type);
+  return hdr.GetSize () + bar.GetSerializedSize () + 4;
+}
+
+uint32_t
 GetRtsSize (void)
 {
   WifiMacHeader rts;
@@ -266,41 +276,4 @@
   return duration;
 }
 
-bool
-IsAmpdu (Ptr<const Packet> packet)
-{
-  AmpduSubframeHeader hdr;
-  //Rely on metadata if present
-  bool metadataEnabled = false;
-  PacketMetadata::ItemIterator metadataIterator = packet->BeginItem ();
-  while (metadataIterator.HasNext ())
-    {
-      metadataEnabled = true;
-      PacketMetadata::Item item = metadataIterator.Next ();
-      if (item.tid == hdr.GetTypeId ())
-        {
-          return true;
-        }
-    }
-  if (metadataEnabled)
-    {
-      //Didn't find header in metadata
-      return false;
-    }
-
-  //No metadata so peek manually into buffer and check consistency of extracted data
-  uint32_t totalSize = packet->GetSize ();
-  uint32_t deserialized = packet->PeekHeader (hdr);
-  if (deserialized == hdr.GetSerializedSize ()
-      && hdr.IsSignatureValid ()
-      && hdr.GetLength () <= (totalSize - deserialized))
-    {
-      return true;
-    }
-  else
-    {
-      return false;
-    }
-}
-
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-utils.h ns-3.31/src/wifi/model/wifi-utils.h
--- ns-3.30.1/src/wifi/model/wifi-utils.h	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-utils.h	2020-06-27 17:38:30.000000000 -0700
@@ -44,9 +44,9 @@
 /**
  * Convert from dB to ratio.
  *
- * \param db
+ * \param db the value in dB
  *
- * \return ratio
+ * \return ratio in linear scale
  */
 double DbToRatio (double db);
 /**
@@ -60,9 +60,9 @@
 /**
  * Convert from ratio to dB.
  *
- * \param ratio
+ * \param ratio the ratio in linear scale
  *
- * \return dB
+ * \return the value in dB
  */
 double RatioToDb (double ratio);
 /**
@@ -76,18 +76,18 @@
  */
 bool Is5Ghz (double frequency);
 /**
- * Convert the guard interval to nanoseconds based on the wifimode.
+ * Convert the guard interval to nanoseconds based on the WifiMode.
  *
- * \param mode the wifimode
+ * \param mode the WifiMode
  * \param device pointer to the WifiNetDevice object
  *
  * \return the guard interval duration in nanoseconds
  */
 uint16_t ConvertGuardIntervalToNanoSeconds (WifiMode mode, const Ptr<WifiNetDevice> device);
 /**
- * Convert the guard interval to nanoseconds based on the wifimode.
+ * Convert the guard interval to nanoseconds based on the WifiMode.
  *
- * \param mode the wifimode
+ * \param mode the WifiMode
  * \param htShortGuardInterval whether HT/VHT short guard interval is enabled
  * \param heGuardInterval the HE guard interval duration
  *
@@ -99,7 +99,7 @@
  *
  * \param modulation the modulation selected for the transmission
  * \param useShortPreamble whether short preamble should be used
- * \param useGreenfield whether HT greenfield should be used
+ * \param useGreenfield whether HT Greenfield should be used
  *
  * \return the preamble to be used for the transmission
  */
@@ -126,28 +126,35 @@
  */
 bool IsAllowedControlAnswerModulationClass (WifiModulationClass modClassReq, WifiModulationClass modClassAnswer);
 /**
- * Return the total ACK size (including FCS trailer).
+ * Return the total Ack size (including FCS trailer).
  *
- * \return the total ACK size
+ * \return the total Ack size in bytes
  */
 uint32_t GetAckSize (void);
 /**
- * Return the total Block ACK size (including FCS trailer).
+ * Return the total BlockAck size (including FCS trailer).
  *
- * \param type the Block ACK type
- * \return the total Block ACK size
+ * \param type the BlockAck type
+ * \return the total BlockAck size in bytes
  */
 uint32_t GetBlockAckSize (BlockAckType type);
 /**
+ * Return the total BlockAckRequest size (including FCS trailer).
+ *
+ * \param type the BlockAckRequest type
+ * \return the total BlockAckRequest size in bytes
+ */
+uint32_t GetBlockAckRequestSize (BlockAckType type);
+/**
  * Return the total RTS size (including FCS trailer).
  *
- * \return the total RTS size
+ * \return the total RTS size in bytes
  */
 uint32_t GetRtsSize (void);
 /**
  * Return the total CTS size (including FCS trailer).
  *
- * \return the total CTS size
+ * \return the total CTS size in bytes
  */
 uint32_t GetCtsSize (void);
 /**
@@ -162,7 +169,7 @@
 /**
  * Add FCS trailer to a packet.
  *
- * \param packet
+ * \param packet the packet to add a trailer to
  */
 void AddWifiMacTrailer (Ptr<Packet> packet);
 /**
@@ -176,29 +183,21 @@
  */
 uint32_t GetSize (Ptr<const Packet> packet, const WifiMacHeader *hdr, bool isAmpdu);
 /**
- * \param packet the packet to check
- * \returns true if packet is an A-MPDU
+ * Get the maximum PPDU duration (see Section 10.14 of 802.11-2016) for
+ * the PHY layers defining the aPPDUMaxTime characteristic (HT, VHT and HE).
+ * Return zero otherwise.
  *
- * This method checks if the packet is an A-MPDU by looking for A-MPDU subframe headers.
+ * \param preamble the preamble type
+ *
+ * \return the maximum PPDU duration, if defined, and zero otherwise
  */
-bool IsAmpdu (Ptr<const Packet> packet);
-
-  /**
-   * Get the maximum PPDU duration (see Section 10.14 of 802.11-2016) for
-   * the PHY layers defining the aPPDUMaxTime characteristic (HT, VHT and HE).
-   * Return zero otherwise.
-   *
-   * \param preamble the preamble type
-   *
-   * \return the maximum PPDU duration, if defined, and zero otherwise
-   */
-  Time GetPpduMaxTime (WifiPreamble preamble);
+Time GetPpduMaxTime (WifiPreamble preamble);
 
-  /// Size of the space of sequence numbers
-  const uint16_t SEQNO_SPACE_SIZE = 4096;
+/// Size of the space of sequence numbers
+const uint16_t SEQNO_SPACE_SIZE = 4096;
 
-  /// Size of the half the space of sequence numbers (used to determine old packets)
-  const uint16_t SEQNO_SPACE_HALF_SIZE = SEQNO_SPACE_SIZE / 2;
+/// Size of the half the space of sequence numbers (used to determine old packets)
+const uint16_t SEQNO_SPACE_HALF_SIZE = SEQNO_SPACE_SIZE / 2;
 } // namespace ns3
 
 #endif /* WIFI_UTILS_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/yans-error-rate-model.cc ns-3.31/src/wifi/model/yans-error-rate-model.cc
--- ns-3.30.1/src/wifi/model/yans-error-rate-model.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/yans-error-rate-model.cc	2020-06-27 17:38:30.000000000 -0700
@@ -196,7 +196,7 @@
               return GetFecBpskBer (snr,
                                     nbits,
                                     txVector.GetChannelWidth () * 1000000, //signal spread
-                                    mode.GetPhyRate (txVector), //phy rate
+                                    mode.GetPhyRate (txVector), //PHY rate
                                     10, //dFree
                                     11); //adFree
             }
@@ -205,7 +205,7 @@
               return GetFecBpskBer (snr,
                                     nbits,
                                     txVector.GetChannelWidth () * 1000000, //signal spread
-                                    mode.GetPhyRate (txVector), //phy rate
+                                    mode.GetPhyRate (txVector), //PHY rate
                                     5, //dFree
                                     8); //adFree
             }
@@ -217,7 +217,7 @@
               return GetFecQamBer (snr,
                                    nbits,
                                    txVector.GetChannelWidth () * 1000000, //signal spread
-                                   mode.GetPhyRate (txVector), //phy rate
+                                   mode.GetPhyRate (txVector), //PHY rate
                                    4, //m
                                    10, //dFree
                                    11, //adFree
@@ -228,7 +228,7 @@
               return GetFecQamBer (snr,
                                    nbits,
                                    txVector.GetChannelWidth () * 1000000, //signal spread
-                                   mode.GetPhyRate (txVector), //phy rate
+                                   mode.GetPhyRate (txVector), //PHY rate
                                    4, //m
                                    5, //dFree
                                    8, //adFree
@@ -242,7 +242,7 @@
               return GetFecQamBer (snr,
                                    nbits,
                                    txVector.GetChannelWidth () * 1000000, //signal spread
-                                   mode.GetPhyRate (txVector), //phy rate
+                                   mode.GetPhyRate (txVector), //PHY rate
                                    16, //m
                                    10, //dFree
                                    11, //adFree
@@ -253,7 +253,7 @@
               return GetFecQamBer (snr,
                                    nbits,
                                    txVector.GetChannelWidth () * 1000000, //signal spread
-                                   mode.GetPhyRate (txVector), //phy rate
+                                   mode.GetPhyRate (txVector), //PHY rate
                                    16, //m
                                    5, //dFree
                                    8, //adFree
@@ -267,7 +267,7 @@
               return GetFecQamBer (snr,
                                    nbits,
                                    txVector.GetChannelWidth () * 1000000, //signal spread
-                                   mode.GetPhyRate (txVector), //phy rate
+                                   mode.GetPhyRate (txVector), //PHY rate
                                    64, //m
                                    6, //dFree
                                    1, //adFree
@@ -279,7 +279,7 @@
               return GetFecQamBer (snr,
                                    nbits,
                                    txVector.GetChannelWidth () * 1000000, //signal spread
-                                   mode.GetPhyRate (txVector), //phy rate
+                                   mode.GetPhyRate (txVector), //PHY rate
                                    64, //m
                                    4, //dFree
                                    14, //adFree
@@ -290,7 +290,7 @@
               return GetFecQamBer (snr,
                                    nbits,
                                    txVector.GetChannelWidth () * 1000000, //signal spread
-                                   mode.GetPhyRate (txVector), //phy rate
+                                   mode.GetPhyRate (txVector), //PHY rate
                                    64, //m
                                    5, //dFree
                                    8, //adFree
@@ -304,7 +304,7 @@
               return GetFecQamBer (snr,
                                    nbits,
                                    txVector.GetChannelWidth () * 1000000, // signal spread
-                                   mode.GetPhyRate (txVector), //phy rate
+                                   mode.GetPhyRate (txVector), //PHY rate
                                    256, // m
                                    4,  // dFree
                                    14,  // adFree
@@ -316,7 +316,7 @@
               return GetFecQamBer (snr,
                                    nbits,
                                    txVector.GetChannelWidth () * 1000000, // signal spread
-                                   mode.GetPhyRate (txVector), //phy rate
+                                   mode.GetPhyRate (txVector), //PHY rate
                                    256, // m
                                    5,  // dFree
                                    8,  // adFree
@@ -331,7 +331,7 @@
               return GetFecQamBer (snr,
                                    nbits,
                                    txVector.GetChannelWidth () * 1000000, // signal spread
-                                   mode.GetPhyRate (txVector), //phy rate
+                                   mode.GetPhyRate (txVector), //PHY rate
                                    1024, // m
                                    4,  // dFree
                                    14,  // adFree
@@ -343,7 +343,7 @@
               return GetFecQamBer (snr,
                                    nbits,
                                    txVector.GetChannelWidth () * 1000000, // signal spread
-                                   mode.GetPhyRate (txVector), //phy rate
+                                   mode.GetPhyRate (txVector), //PHY rate
                                    1024, // m
                                    5,  // dFree
                                    8,  // adFree
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/yans-error-rate-model.h ns-3.31/src/wifi/model/yans-error-rate-model.h
--- ns-3.30.1/src/wifi/model/yans-error-rate-model.h	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/yans-error-rate-model.h	2020-06-27 17:38:30.000000000 -0700
@@ -41,10 +41,10 @@
  *    - 1 Mbps mode is based on DBPSK. BER is from equation 5.2-69 from John G. Proakis
  *      Digital Communications, 2001 edition
  *    - 2 Mbps model is based on DQPSK. Equation 8 from "Tight bounds and accurate
- *      approximations for dqpsk transmission bit error rate", G. Ferrari and G.E. Corazza
+ *      approximations for DQPSK transmission bit error rate", G. Ferrari and G.E. Corazza
  *      ELECTRONICS LETTERS, 40(20):1284-1285, September 2004
  *    - 5.5 Mbps and 11 Mbps are based on equations (18) and (17) from "Properties and
- *      performance of the ieee 802.11b complementarycode-key signal sets",
+ *      performance of the IEEE 802.11b complementary code-key signal sets",
  *      Michael B. Pursley and Thomas C. Royster. IEEE TRANSACTIONS ON COMMUNICATIONS,
  *      57(2):440-449, February 2009.
  *    - More detailed description and validation can be found in
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/yans-wifi-channel.cc ns-3.31/src/wifi/model/yans-wifi-channel.cc
--- ns-3.30.1/src/wifi/model/yans-wifi-channel.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/yans-wifi-channel.cc	2020-06-27 17:38:30.000000000 -0700
@@ -18,7 +18,6 @@
  * Author: Mathieu Lacage, <mathieu.lacage@sophia.inria.fr>
  */
 
-#include "ns3/packet.h"
 #include "ns3/simulator.h"
 #include "ns3/log.h"
 #include "ns3/pointer.h"
@@ -30,6 +29,8 @@
 #include "yans-wifi-channel.h"
 #include "yans-wifi-phy.h"
 #include "wifi-utils.h"
+#include "wifi-ppdu.h"
+#include "wifi-psdu.h"
 
 namespace ns3 {
 
@@ -82,9 +83,9 @@
 }
 
 void
-YansWifiChannel::Send (Ptr<YansWifiPhy> sender, Ptr<const Packet> packet, double txPowerDbm, Time duration) const
+YansWifiChannel::Send (Ptr<YansWifiPhy> sender, Ptr<const WifiPpdu> ppdu, double txPowerDbm) const
 {
-  NS_LOG_FUNCTION (this << sender << packet << txPowerDbm << duration.GetSeconds ());
+  NS_LOG_FUNCTION (this << sender << ppdu << txPowerDbm);
   Ptr<MobilityModel> senderMobility = sender->GetMobility ();
   NS_ASSERT (senderMobility != 0);
   for (PhyList::const_iterator i = m_phyList.begin (); i != m_phyList.end (); i++)
@@ -102,7 +103,7 @@
           double rxPowerDbm = m_loss->CalcRxPower (txPowerDbm, senderMobility, receiverMobility);
           NS_LOG_DEBUG ("propagation: txPower=" << txPowerDbm << "dbm, rxPower=" << rxPowerDbm << "dbm, " <<
                         "distance=" << senderMobility->GetDistanceFrom (receiverMobility) << "m, delay=" << delay);
-          Ptr<Packet> copy = packet->Copy ();
+          Ptr<WifiPpdu> copy = Copy (ppdu);
           Ptr<NetDevice> dstNetDevice = (*i)->GetDevice ();
           uint32_t dstNode;
           if (dstNetDevice == 0)
@@ -116,23 +117,23 @@
 
           Simulator::ScheduleWithContext (dstNode,
                                           delay, &YansWifiChannel::Receive,
-                                          (*i), copy, rxPowerDbm, duration);
+                                          (*i), copy, rxPowerDbm);
         }
     }
 }
 
 void
-YansWifiChannel::Receive (Ptr<YansWifiPhy> phy, Ptr<Packet> packet, double rxPowerDbm, Time duration)
+YansWifiChannel::Receive (Ptr<YansWifiPhy> phy, Ptr<WifiPpdu> ppdu, double rxPowerDbm)
 {
-  NS_LOG_FUNCTION (phy << packet << rxPowerDbm << duration.GetSeconds ());
+  NS_LOG_FUNCTION (phy << ppdu << rxPowerDbm);
   // Do no further processing if signal is too weak
-  // Current implementation assumes constant rx power over the packet duration
+  // Current implementation assumes constant RX power over the PPDU duration
   if ((rxPowerDbm + phy->GetRxGain ()) < phy->GetRxSensitivity ())
     {
       NS_LOG_INFO ("Received signal too weak to process: " << rxPowerDbm << " dBm");
       return;
     }
-  phy->StartReceivePreamble (packet, DbmToW (rxPowerDbm + phy->GetRxGain ()), duration);
+  phy->StartReceivePreamble (ppdu, DbmToW (rxPowerDbm + phy->GetRxGain ()));
 }
 
 std::size_t
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/yans-wifi-channel.h ns-3.31/src/wifi/model/yans-wifi-channel.h
--- ns-3.30.1/src/wifi/model/yans-wifi-channel.h	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/yans-wifi-channel.h	2020-06-27 17:38:30.000000000 -0700
@@ -31,6 +31,7 @@
 class YansWifiPhy;
 class Packet;
 class Time;
+class WifiPpdu;
 
 /**
  * \brief a channel to interconnect ns3::YansWifiPhy objects.
@@ -74,17 +75,16 @@
   void SetPropagationDelayModel (const Ptr<PropagationDelayModel> delay);
 
   /**
-   * \param sender the phy object from which the packet is originating.
-   * \param packet the packet to send
-   * \param txPowerDbm the tx power associated to the packet, in dBm
-   * \param duration the transmission duration associated with the packet
+   * \param sender the PHY object from which the packet is originating.
+   * \param ppdu the PPDU to send
+   * \param txPowerDbm the TX power associated to the packet, in dBm
    *
    * This method should not be invoked by normal users. It is
    * currently invoked only from YansWifiPhy::StartTx.  The channel
-   * attempts to deliver the packet to all other YansWifiPhy objects
+   * attempts to deliver the PPDU to all other YansWifiPhy objects
    * on the channel (except for the sender).
    */
-  void Send (Ptr<YansWifiPhy> sender, Ptr<const Packet> packet, double txPowerDbm, Time duration) const;
+  void Send (Ptr<YansWifiPhy> sender, Ptr<const WifiPpdu> ppdu, double txPowerDbm) const;
 
   /**
    * Assign a fixed random variable stream number to the random variables
@@ -107,14 +107,13 @@
   /**
    * This method is scheduled by Send for each associated YansWifiPhy.
    * The method then calls the corresponding YansWifiPhy that the first
-   * bit of the packet has arrived.
+   * bit of the PPDU has arrived.
    *
    * \param receiver the device to which the packet is destined
-   * \param packet the packet being sent
-   * \param txPowerDbm the tx power associated to the packet being sent (dBm)
-   * \param duration the transmission duration associated with the packet being sent
+   * \param ppdu the PPDU being sent
+   * \param txPowerDbm the TX power associated to the packet being sent (dBm)
    */
-  static void Receive (Ptr<YansWifiPhy> receiver, Ptr<Packet> packet, double txPowerDbm, Time duration);
+  static void Receive (Ptr<YansWifiPhy> receiver, Ptr<WifiPpdu> ppdu, double txPowerDbm);
 
   PhyList m_phyList;                   //!< List of YansWifiPhys connected to this YansWifiChannel
   Ptr<PropagationLossModel> m_loss;    //!< Propagation loss model
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/yans-wifi-phy.cc ns-3.31/src/wifi/model/yans-wifi-phy.cc
--- ns-3.30.1/src/wifi/model/yans-wifi-phy.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/yans-wifi-phy.cc	2020-06-27 17:38:30.000000000 -0700
@@ -21,9 +21,9 @@
  */
 
 #include "ns3/log.h"
-#include "ns3/packet.h"
 #include "yans-wifi-phy.h"
 #include "yans-wifi-channel.h"
+#include "wifi-ppdu.h"
 
 namespace ns3 {
 
@@ -75,10 +75,12 @@
 }
 
 void
-YansWifiPhy::StartTx (Ptr<Packet> packet, WifiTxVector txVector, Time txDuration)
+YansWifiPhy::StartTx (Ptr<WifiPpdu> ppdu)
 {
+  NS_LOG_FUNCTION (this << ppdu);
+  WifiTxVector txVector = ppdu->GetTxVector ();
   NS_LOG_DEBUG ("Start transmission: signal power before antenna gain=" << GetPowerDbm (txVector.GetTxPowerLevel ()) << "dBm");
-  m_channel->Send (this, packet, GetTxPowerForTransmission (txVector) + GetTxGain (), txDuration);
+  m_channel->Send (this, ppdu, GetTxPowerForTransmission (txVector) + GetTxGain ());
 }
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/yans-wifi-phy.h ns-3.31/src/wifi/model/yans-wifi-phy.h
--- ns-3.30.1/src/wifi/model/yans-wifi-phy.h	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/yans-wifi-phy.h	2020-06-27 17:38:30.000000000 -0700
@@ -28,6 +28,7 @@
 namespace ns3 {
 
 class YansWifiChannel;
+class WifiPpdu;
 
 /**
  * \brief 802.11 PHY layer model
@@ -56,6 +57,10 @@
   YansWifiPhy ();
   virtual ~YansWifiPhy ();
 
+  // Implementation of pure virtual method.
+  void StartTx (Ptr<WifiPpdu> ppdu);
+  virtual Ptr<Channel> GetChannel (void) const;
+
   /**
    * Set the YansWifiChannel this YansWifiPhy is to be connected to.
    *
@@ -63,18 +68,6 @@
    */
   void SetChannel (const Ptr<YansWifiChannel> channel);
 
-  /**
-   * \param packet the packet to send
-   * \param txVector the TXVECTOR that has tx parameters such as mode, the transmission mode to use to send
-   *        this packet, and txPowerLevel, a power level to use to send this packet. The real transmission
-   *        power is calculated as txPowerMin + txPowerLevel * (txPowerMax - txPowerMin) / nTxLevels
-   * \param txDuration duration of the transmission.
-   */
-  void StartTx (Ptr<Packet> packet, WifiTxVector txVector, Time txDuration);
-
-  virtual Ptr<Channel> GetChannel (void) const;
-
-
 protected:
   // Inherited
   virtual void DoDispose (void);
